﻿using System.Drawing;

using DevExpress.Utils.Drawing;
using DevExpress.Utils.Text;
using DevExpress.XtraSplashScreen;

namespace TestProject
{
    /// <summary>
    /// 커스텀 이미지 페인터
    /// </summary>
    class CustomImagePainter : ICustomImagePainter
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 뷰 정보
        /// </summary>
        private ViewInfo viewInfo = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 페인터 - Painter

        /// <summary>
        /// 페인터
        /// </summary>
        public static CustomImagePainter Painter { get; private set; }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 뷰 정보 - ViewInfo

        /// <summary>
        /// 뷰 정보
        /// </summary>
        public ViewInfo ViewInfo
        {
            get
            {
                if(this.viewInfo == null)
                {
                    this.viewInfo = new ViewInfo();
                }

                return this.viewInfo;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region 생성자 - CustomImagePainter()

        /// <summary>
        /// 생성자
        /// </summary>
        static CustomImagePainter()
        {
            Painter = new CustomImagePainter();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region 생성자 - CustomImagePainter()

        /// <summary>
        /// 생성자
        /// </summary>
        protected CustomImagePainter()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 그리기 - Draw(graphicsCache, boundRectangle)

        /// <summary>
        /// 그리기
        /// </summary>
        /// <param name="graphicsCache">그래픽스 캐시</param>
        /// <param name="boundRectangle">경계 사각형</param>
        public void Draw(GraphicsCache graphicsCache, Rectangle boundRectangle)
        {
            PointF point = ViewInfo.CalculateProgressLabelPoint(graphicsCache, boundRectangle);

            graphicsCache.Graphics.DrawString(ViewInfo.Text, ViewInfo.ProgressLabelFont, ViewInfo.Brush, point);
        }

        #endregion
    }
}