﻿using System;
using System.Windows.Forms;

using DevExpress.XtraSplashScreen;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Initialize();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 로드시 처리하기 - OnLoad(e)

        /// <summary>
        /// 로드시 처리하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            SplashScreenManager.HideImage();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 기본 데이터 로드하기 - LoadBasicData()

        /// <summary>
        /// 기본 데이터 로드하기
        /// </summary>
        private void LoadBasicData()
        {
            CustomImagePainter.Painter.ViewInfo.Stage = "기본 데이터 로딩";

            for(int i = 1; i <= 100; i++)
            {
                System.Threading.Thread.Sleep(20);
                
                CustomImagePainter.Painter.ViewInfo.Counter = i;

                SplashScreenManager.Default.Invalidate();
            }
        }

        #endregion
        #region 폰트 데이터 로드하기 - LoadFontData()

        /// <summary>
        /// 폰트 데이터 로드하기
        /// </summary>
        private void LoadFontData()
        {
            CustomImagePainter.Painter.ViewInfo.Stage = "폰트 데이터 로딩";

            for(int i = 1; i <= 100; i++)
            {
                System.Threading.Thread.Sleep(20);

                CustomImagePainter.Painter.ViewInfo.Counter = i;

                SplashScreenManager.Default.Invalidate();
            }
        }

        #endregion
        #region 텍스처 데이터 로드하기 - LoadTextureData()

        /// <summary>
        /// 텍스처 데이터 로드하기
        /// </summary>
        private void LoadTextureData()
        {
            CustomImagePainter.Painter.ViewInfo.Stage = "텍스처 데이터 로딩";

            for(int i = 1; i <= 100; i++)
            {
                System.Threading.Thread.Sleep(20);

                CustomImagePainter.Painter.ViewInfo.Counter = i;

                SplashScreenManager.Default.Invalidate();
            }
        }

        #endregion
        #region 초기화 하기 - Initialize()

        /// <summary>
        /// 초기화 하기 
        /// </summary>
        protected void Initialize()
        {
            LoadBasicData();

            LoadFontData();

            LoadTextureData();
        }

        #endregion
    }
}