﻿using System;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;

using DevExpress.XtraSplashScreen;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    static class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 이미지 구하기 - GetImage()

        /// <summary>
        /// 이미지 구하기
        /// </summary>
        /// <returns>이미지</returns>
        private static Image GetImage()
        {
            Assembly assembly = typeof(Program).Assembly;
 
            return new Bitmap(assembly.GetManifestResourceStream("TestProject.Images.sample.png"));
        }

        #endregion
        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            Image image = GetImage();

            SplashScreenManager.ShowImage(image, true, true, CustomImagePainter.Painter);

            Application.Run(new MainForm());
        }

        #endregion
    }
}